<template>
    <v-row>
        <v-col>
            <account-form v-model="user" :clearable="false" mode="edit"></account-form>
        </v-col>
    </v-row>
</template>

<script>
import AccountForm from "./AccountForm";

export default {
    name: "AccountEdit",
    components: {AccountForm},
    props: {
        id: [String, Number],
    },
    data: () => ({
        user: {
            id: 0,
            first_name: "",
            last_name: "",
            role_id: null,
            mobile: "",
            affiliate: {
                parent_id: 0,
                commission: 0,
                discount_code: {
                    discount: 0,
                    discount_type_id: 0,
                    discount_method_id: 0,
                },
            },
        },
    }),

    mounted() {
        this.fetchAccount().then((data) => {
            this.mapAccount(data);
            this.loading = false;
        });
    },

    methods: {
        fetchAccount() {
            return new Promise((resolve, reject) => {
                axios
                    .get("api/account/" + this.id)
                    .then(({data}) => {
                        resolve(data);
                    })
                    .catch((error) => {
                        reject(error);
                    });
            });
        },

        mapAccount(user) {
            this.user.id = user.id;
            this.user.first_name = user.profile.first_name;
            this.user.last_name = user.profile.last_name;
            this.user.mobile = user.profile.mobile;
            this.user.role_id = user.roles[0].id;

            if (user.affiliate != null) {
                this.user.affiliate.parent_id = user.affiliate.parent_id;
                this.user.affiliate.commission = user.affiliate.commission;
                this.user.affiliate.discount_code.discount = user.affiliate.discount_code.discount;
                this.user.affiliate.discount_code.discount_type_id = user.affiliate.discount_code.discount_type.id;
                this.user.affiliate.discount_code.discount_method_id = user.affiliate.discount_code.discount_method.id;
            }
        },
    },
};
</script>

<style scoped>
</style>
